Package org.apache.commons.math3.analysis.solvers

# Interface BaseUnivariateSolver<FUNC extends UnivariateFunction>

Type Parameters:
  `FUNC` - Type of function to solve.

All Known Subinterfaces:
  `BracketedUnivariateSolver<FUNC>`, `DifferentiableUnivariateSolver`, `PolynomialSolver`, `UnivariateDifferentiableSolver`, `UnivariateSolver`

All Known Implementing Classes:
  `AbstractDifferentiableUnivariateSolver`, `AbstractPolynomialSolver`, `AbstractUnivariateDifferentiableSolver`, `AbstractUnivariateSolver`, `BaseAbstractUnivariateSolver`, `BaseSecantSolver`, `BisectionSolver`, `BracketingNthOrderBrentSolver`, `BrentSolver`, `IllinoisSolver`, `LaguerreSolver`, `MullerSolver`, `MullerSolver2`, `NewtonRaphsonSolver`, `NewtonSolver`, `PegasusSolver`, `RegulaFalsiSolver`, `RiddersSolver`, `SecantSolver`

public interface BaseUnivariateSolver<FUNC extends UnivariateFunction>
Interface for (univariate real) rootfinding algorithms. Implementations will search for only one zero in the given interval. This class is not intended for use outside of the Apache Commons Math library, regular user should rely on more specific interfaces like `UnivariateSolver`, `PolynomialSolver` or `DifferentiableUnivariateSolver`.

Since:
  3.0
See Also:
  - `UnivariateSolver`
  - `PolynomialSolver`
  - `DifferentiableUnivariateSolver`

## Method Summary

Modifier and Type
Method
Description
`double`
`getAbsoluteAccuracy()`
Get the absolute accuracy of the solver.
`int`
`getEvaluations()`
Get the number of evaluations of the objective function.
`double`
`getFunctionValueAccuracy()`
Get the function value accuracy of the solver.
`int`
`getMaxEvaluations()`
Get the maximum number of function evaluations.
`double`
`getRelativeAccuracy()`
Get the relative accuracy of the solver.
`double`
`solve(int maxEval, FUNC f, double startValue)`
Solve for a zero in the vicinity of `startValue`.
`double`
`solve(int maxEval, FUNC f, double min, double max)`
Solve for a zero root in the given interval.
`double`
`solve(int maxEval, FUNC f, double min, double max, double startValue)`
Solve for a zero in the given interval, start at `startValue`.

## Method Details

### getMaxEvaluations

int getMaxEvaluations()
Get the maximum number of function evaluations.

Returns:
  the maximum number of function evaluations.

### getEvaluations

int getEvaluations()
Get the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.

Returns:
  the number of evaluations of the objective function.

### getAbsoluteAccuracy

double getAbsoluteAccuracy()
Get the absolute accuracy of the solver. Solutions returned by the solver should be accurate to this tolerance, i.e., if ε is the absolute accuracy of the solver and `v` is a value returned by one of the `solve` methods, then a root of the function should exist somewhere in the interval (`v` - ε, `v` + ε).

Returns:
  the absolute accuracy.

### getRelativeAccuracy

double getRelativeAccuracy()
Get the relative accuracy of the solver. The contract for relative accuracy is the same as `getAbsoluteAccuracy()`, but using relative, rather than absolute error. If ρ is the relative accuracy configured for a solver and `v` is a value returned, then a root of the function should exist somewhere in the interval (`v` - ρ `v`, `v` + ρ `v`).

Returns:
  the relative accuracy.

### getFunctionValueAccuracy

double getFunctionValueAccuracy()
Get the function value accuracy of the solver. If `v` is a value returned by the solver for a function `f`, then by contract, `|f(v)|` should be less than or equal to the function value accuracy configured for the solver.

Returns:
  the function value accuracy.

### solve

double solve(int maxEval, FUNC f, double min, double max) throws MathIllegalArgumentException, TooManyEvaluationsException
Solve for a zero root in the given interval. A solver may require that the interval brackets a single zero root. Solvers that do require bracketing should be able to handle the case where one of the endpoints is itself a root.

Parameters:
  `maxEval` - Maximum number of evaluations.
  `f` - Function to solve.
  `min` - Lower bound for the interval.
  `max` - Upper bound for the interval.
Returns:
  a value where the function is zero.
Throws:
  `MathIllegalArgumentException` - if the arguments do not satisfy the requirements specified by the solver.
  `TooManyEvaluationsException` - if the allowed number of evaluations is exceeded.

### solve

double solve(int maxEval, FUNC f, double min, double max, double startValue) throws MathIllegalArgumentException, TooManyEvaluationsException
Solve for a zero in the given interval, start at `startValue`. A solver may require that the interval brackets a single zero root. Solvers that do require bracketing should be able to handle the case where one of the endpoints is itself a root.

Parameters:
  `maxEval` - Maximum number of evaluations.
  `f` - Function to solve.
  `min` - Lower bound for the interval.
  `max` - Upper bound for the interval.
  `startValue` - Start value to use.
Returns:
  a value where the function is zero.
Throws:
  `MathIllegalArgumentException` - if the arguments do not satisfy the requirements specified by the solver.
  `TooManyEvaluationsException` - if the allowed number of evaluations is exceeded.

### solve

double solve(int maxEval, FUNC f, double startValue)
Solve for a zero in the vicinity of `startValue`.

Parameters:
  `maxEval` - Maximum number of evaluations.
  `f` - Function to solve.
  `startValue` - Start value to use.
Returns:
  a value where the function is zero.
Throws:
  `MathIllegalArgumentException` - if the arguments do not satisfy the requirements specified by the solver.
  `TooManyEvaluationsException` - if the allowed number of evaluations is exceeded.